// Timer gesteuerter Funktionsbutton schaltet Relais

const int pin_Button = 6;               // belegte Pins am Arduino
const int pin_Relais = 7;  
const int pin_LED_rot = 8; 
const int pin_LED_gruen = 9;  

const int Zeit_Aktiv = 5000 ;           // Aktive Zeit (Millisekunden)
const int Zeit_Pause = 3000 ;           // Inaktive Zeit (Millisekunden)
unsigned long Zeit_Start = 0 ;          // speichert Zeitzustand

bool Button_Zustand = 0;                // liest den pin_Button
bool Button_Zustand_merken = 0;         // liest den pin_Button
bool Aktiv = 0;                         // geschaltet

void setup() {
  Serial.begin(9600);                   // Starte die serielle Verbindung
  pinMode(pin_Button, INPUT_PULLUP);    // Setze den Pin als Eingang
  pinMode(pin_Relais, OUTPUT);          // Setze den Pin als Ausgang
  
  digitalWrite(pin_LED_rot, 0);         // LED Voreinstellung
  digitalWrite(pin_LED_gruen, 1);
}

void loop() {
  unsigned long Zeit_Aktuell = millis ( ) ; 
  Button_Zustand = !digitalRead(pin_Button);

  if (Button_Zustand != Button_Zustand_merken) {
    Button_Zustand_merken = Button_Zustand;
    if (Button_Zustand == 1) {          // Wenn der Button gedrückt wurde
      if (Aktiv == 0) {
        Zeit_Start = Zeit_Aktuell;      // aktueller Zeitzustand (millis)
        digitalWrite(pin_Relais, 1);    // Relais einschalten
        digitalWrite(pin_LED_gruen, 0); // Grüne LED ausschalten
        digitalWrite(pin_LED_rot, 1);   // Rote LED einschalten 
        Aktiv = 1;
      }
      else {
        digitalWrite(pin_Relais, 0);    //Relais ausschalten
      } 
    }
  }

  // Aktiv-Zeit abwarten
  if ( Zeit_Aktuell - Zeit_Start >= Zeit_Aktiv ){
    digitalWrite(pin_Relais, 0);        //Relais ausschalten
  }

  // In Aktiv-Zeit abwarten 
  if ( Zeit_Aktuell - Zeit_Start >= Zeit_Aktiv + Zeit_Pause ){ 
    digitalWrite(pin_LED_rot, 0);       //Rote LED einschalten
    digitalWrite(pin_LED_gruen, 1);     //Grüne LED ausschalten
    Aktiv = 0;
  }    
}
